<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="xml" indent="yes" omit-xml-declaration="yes"/>
	<xsl:strip-space elements="*"/>
	<!-- Deciding Params-->
	<xsl:param name="outfmt">12</xsl:param>
	<xsl:param name="deviceclass"/>
	<xsl:param name="device-index"></xsl:param>
	<!-- Deciding Params-->
	<xsl:variable name="deviceClassNotFound">The device class requested is not present/enumerated.</xsl:variable>
	<xsl:variable name="deviceIndexNotFound">No matching device was found while querying diagnostic device(s).</xsl:variable>
	<xsl:variable name="someDeviceIndexNotFound">No matching device was found for the device index</xsl:variable>
	<xsl:variable name="modDevice-index" select="concat(',', $device-index, ',')"/>

	<xsl:template match="tree">
		<xsl:variable name="deviceCount" select="count(.//device)"/>
		<xsl:choose>
			<xsl:when test="$deviceCount &gt; 0">
				<!--
				<xsl:call-template name="NewLine"/>
				<xsl:element name="tree">
					<xsl:apply-templates select="device" mode="xml"/>
				</xsl:element>
				<xsl:call-template name="NewLine"/>
				-->
				<xsl:choose>
					<xsl:when test="$device-index !=''">
						<xsl:choose>
							<xsl:when test="contains($device-index, ',')">
								<xsl:variable name="NoMatchedIndex">
									<xsl:call-template name="MatchIndices">
										<xsl:with-param name="totalCount" select="$deviceCount"/>
										<xsl:with-param name="tokenizedIndex" select="$device-index"/>
									</xsl:call-template>
								</xsl:variable>
								<xsl:variable name="partialDisplayed">
									<xsl:call-template name="SpecifyPartialDisplay">
										<xsl:with-param name="totalCount" select="$deviceCount"/>
										<xsl:with-param name="tokenizedIndex" select="$device-index"/>
									</xsl:call-template>
								</xsl:variable>
								<xsl:choose>
									<xsl:when test="$NoMatchedIndex !=''">
										<xsl:choose>
											<xsl:when test="contains($partialDisplayed, 'yes')">
												<xsl:call-template name="NewLine"/>
												<xsl:element name="tree">
													<xsl:apply-templates select="device" mode="xml"/>
												</xsl:element>
												<xsl:call-template name="NewLine"/>
												<xsl:call-template name="NewLine"/>
												<xsl:value-of select="$someDeviceIndexNotFound"/> - <xsl:value-of select="substring-after($NoMatchedIndex, ',')"/>
												<xsl:call-template name="NewLine"/>
											</xsl:when>
											<xsl:otherwise>
												<xsl:call-template name="NewLine"/>
												<xsl:value-of select="$deviceIndexNotFound"/>
												<xsl:call-template name="NewLine"/>
											</xsl:otherwise>
										</xsl:choose>
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="NewLine"/>
										<xsl:element name="tree">
											<xsl:apply-templates select="device" mode="xml"/>
										</xsl:element>
										<xsl:call-template name="NewLine"/>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							<xsl:otherwise>
								<xsl:choose>
									<xsl:when test="$device-index &gt; $deviceCount">
										<xsl:call-template name="NewLine"/>
										<xsl:value-of select="$deviceIndexNotFound"/>
										<xsl:call-template name="NewLine"/>
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="NewLine"/>
										<xsl:element name="tree">
											<xsl:apply-templates select="device" mode="xml"/>
										</xsl:element>
										<xsl:call-template name="NewLine"/>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="NewLine"/>
						<xsl:element name="tree">
							<xsl:apply-templates select="device" mode="xml"/>
						</xsl:element>
						<xsl:call-template name="NewLine"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="NewLine"/>
				<xsl:value-of select="$deviceClassNotFound"/>
				<xsl:call-template name="NewLine"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="MatchIndices">
		<xsl:param name="totalCount"/>
		<xsl:param name="tokenizedIndex"/>
		<xsl:choose>
			<xsl:when test="contains($tokenizedIndex, ',')">
				<xsl:if test="substring-before($tokenizedIndex, ',') &gt; $totalCount">,<xsl:value-of select="substring-before($tokenizedIndex, ',')"/></xsl:if>
				<xsl:call-template name="MatchIndices">
					<xsl:with-param name="totalCount" select="$totalCount"/>
					<xsl:with-param name="tokenizedIndex" select="substring-after($tokenizedIndex, ',')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:if test="$tokenizedIndex &gt; $totalCount">,<xsl:value-of select="$tokenizedIndex"/></xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="SpecifyPartialDisplay">
		<xsl:param name="totalCount"/>
		<xsl:param name="tokenizedIndex"/>
		<xsl:choose>
			<xsl:when test="contains($tokenizedIndex, ',')">
				<xsl:if test="substring-before($tokenizedIndex, ',') &lt;= $totalCount">yes,</xsl:if>
				<xsl:call-template name="SpecifyPartialDisplay">
					<xsl:with-param name="totalCount" select="$totalCount"/>
					<xsl:with-param name="tokenizedIndex" select="substring-after($tokenizedIndex, ',')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:if test="$tokenizedIndex &lt;= $totalCount">yes,</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

<!--
	<xsl:template match="tree">
		<xsl:variable name="deviceCount" select="count(.//device)"/>
		<xsl:choose>
			<xsl:when test="$deviceCount &gt; 0">
				<xsl:call-template name="NewLine"/>
				<xsl:element name="tree">
					<xsl:apply-templates select="device" mode="xml"/>
				</xsl:element>
				<xsl:call-template name="NewLine"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="NewLine"/>
				<xsl:value-of select="$deviceClassNotFound"/>
				<xsl:call-template name="NewLine"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
-->
	<xsl:template match="device" mode="xml">
		<xsl:variable name="index"><xsl:number level="any"/></xsl:variable>
		<xsl:choose>
			<xsl:when test="$device-index !=''">
				<xsl:if test="contains($modDevice-index, concat(',', $index, ','))">
					<xsl:copy>
						<xsl:attribute name="index"><xsl:value-of select="$index"/></xsl:attribute>
						<xsl:apply-templates select="@* | node()" mode="xml"/>
					</xsl:copy>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:attribute name="index"><xsl:value-of select="$index"/></xsl:attribute>
					<xsl:apply-templates select="@* | node()" mode="xml"/>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="test" mode="xml">
	</xsl:template>

	<xsl:template match="@* | node()" mode="xml">
		<xsl:if test="(name() != '_Key') and (name() !='sequenceKey')">
		<xsl:copy>
			<xsl:copy-of select="@*"/>
			<xsl:apply-templates select="node()" mode="xml"/>
		</xsl:copy>
		</xsl:if>
	</xsl:template>

	<xsl:template name="NewLine">
		<xsl:text>
</xsl:text>
	</xsl:template>
	<xsl:template match="*"></xsl:template>	
</xsl:stylesheet>