<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="text"  indent="no" omit-xml-declaration="yes"/>
	<xsl:strip-space elements="*"/>
	<xsl:variable name="spaceVar">13</xsl:variable>
	<xsl:variable name="HeaderCmd">Command</xsl:variable>
	<xsl:variable name="HeaderDesc">Description</xsl:variable>
	<xsl:template match="commandhelp">
		<xsl:call-template name="NewLine"/>
		<xsl:if test="count(.//command) &gt; 0">The available device class(es) are:
			<xsl:call-template name="NewLine"/>
			<xsl:call-template name="CLISubCommand">
				<xsl:with-param name="command">
					<xsl:value-of select="$HeaderCmd"/>
				</xsl:with-param>
			</xsl:call-template>:<xsl:text> </xsl:text>
			<xsl:value-of select="normalize-space($HeaderDesc)"/>
			<xsl:apply-templates select="command"/>
			<xsl:call-template name="NewLine"/>
		</xsl:if>
	</xsl:template>
	<xsl:template match="command">
		<xsl:if test="(@name != '') and (@desc != '')">
			<xsl:call-template name="NewLine"/>
			<xsl:call-template name="CLISubCommand">
				<xsl:with-param name="command">
					<xsl:value-of select="@name"/>
				</xsl:with-param>
			</xsl:call-template>:<xsl:text> </xsl:text>
			<xsl:value-of select="normalize-space(@desc)"/>
		</xsl:if>
	</xsl:template>

	<xsl:template name="CLISubCommand">
		<xsl:param name="command"/>
		<xsl:if test="$command != ''">
			<xsl:value-of select="$command"/>
			<xsl:call-template name="Listspaces">
				<xsl:with-param name="num">
					<xsl:value-of select="($spaceVar) -  string-length($command)"/>
				</xsl:with-param>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>
	
	<xsl:template name="Listspaces">
		<xsl:param name="num"/>
		<xsl:text> </xsl:text>
		<xsl:if test="$num &gt; '0'">
			<xsl:call-template name="Listspaces">
				<xsl:with-param name="num">
					<xsl:value-of select="($num) - 1"/>
				</xsl:with-param>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>
	
	<xsl:template name="NewLine">
		<xsl:text>
</xsl:text>
	</xsl:template>
	<xsl:template match="*"></xsl:template>
</xsl:stylesheet>
