<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	 <xsl:output method="html" /> 
	<xsl:template match="/">
		<head>
			<link href="docs/en/css/oma.css" type="text/css" rel="stylesheet"/><link type="text/css" rel="stylesheet" href="docs/en/css/scheme.css"/>
			<title>Dell PowerEdge Diagnostics - Configuration</title>
		</head>
	
	<body class="data-area"> 
		<span id="pagetitle" class="data-area-page-title">Dell PowerEdge Diagnostics - Configuration</span>
		<table cellspacing="0" cellpadding="0" border="0">            
			<tbody><tr style="height: 20px;"><td><img src="./images/blank.gif"></img></td></tr></tbody>
		</table>  

		<div style="display: none;" id="tableBar">               
			<table border="0" cellspacing="0" cellpadding="0" width="100%">    
				<tbody>
					<tr>
						<td style="width: 15px;"></td><td style="width: 11px;" align="right"><img style="width: 11px; height: 20px;" src="./images/dajblc.gif"></img></td>
						<td class="data-area-jump-bar">                            
							<table border="0" cellspacing="0" cellpadding="0" height="20">                                
								<tbody><tr id="oJumpDataRow" valign="middle"></tr></tbody>
							</table>                        
						</td>
						<td style="width: 11px;"><img style="width: 11px; height: 20px;" src="./images/dajbrc.gif"></img></td><td style="width: 15px;"></td>
					</tr>
				</tbody>
			</table>
			<br></br>
		</div>            

		<table border="0" cellspacing="0" cellpadding="0" width="100%">                
			<tbody>
				<tr>
					<td style="width: 15px;"></td><td style="width: 10px; height: 10px;"><img style="width: 10px; height: 10px;" src="./images/tl.gif"></img></td>
					<td class="data-area-canvas" style="height: 10px;"><img style="width: 1px; height: 1px;" src=""></img></td>
					<td style="width: 10px; height: 10px;"><img style="width: 10px; height: 10px;" src="./images/tr.gif"></img></td>
					<td style="width: 15px;"></td> 
				</tr>
				<tr>
					<td style="width: 15px;"></td><td class="data-area-canvas" style="height: 10px;"><img style="width: 1px; height: 1px;" src=""></img></td>
					<td class="data-area-canvas">
						<table border="0" cellspacing="0" cellpadding="0" width="100%">
							<tbody>
								<tr>
									<th align="left" valign="middle" class="data-area-header">Device Name</th>
									<th align="left" valign="middle" class="data-area-header">Device Attribute<img style="width: 10px; height: 10px;" src="./images/blank.gif"></img></th>
									<th align="left" valign="middle" class="data-area-header">Value</th>
								</tr>
								<tr>
									<td style="height: 1px;" class="data-area-separator"><img style="width: 1px; height: 1px;" src=""></img></td><td style="height: 1px;" class="data-area-separator"><img style="width: 1px; height: 1px;" src=""></img></td><td style="height: 1px;" class="data-area-separator"><img style="width: 1px; height: 1px;" src=""></img></td>
								</tr>
								<xsl:apply-templates/>
							</tbody>
						</table>                   
					</td><td class="data-area-canvas" style="height: 10px;"><img style="width: 1px; height: 1px;" src=""></img></td><td style="width: 15px;"></td></tr><tr><td style="width: 15px;"></td><td style="width: 10px; height: 10px;"><img style="width: 10px; height: 10px;" src="./images/bl.gif"></img></td><td class="data-area-canvas" style="height: 10px;"><img style="width: 1px; height: 1px;" src=""></img></td><td style="width: 10px; height: 10px;"><img style="width: 10px; height: 10px;" src="./images/br.gif"></img></td><td style="width: 15px;"></td></tr>
			</tbody>
		</table>
          	<br></br>            
		<center><table cellspacing="0" cellpadding="0" border="0"><tbody><tr><td style="height: 30px;"></td></tr><tr></tr></tbody></table></center>               	
	</body>
</xsl:template>

<xsl:template match="device">
	<xsl:variable name="canvas" select="position() mod 2 = 0"></xsl:variable>
    	<xsl:variable name="not_canvas" select="position() mod 2 != 0"></xsl:variable>
    	<xsl:variable name="status" select="deviceStatus"></xsl:variable>
    	<xsl:variable name="statuscode" select="deviceStatusCode"></xsl:variable>
    	<xsl:if test="$canvas">
       	<tr>		
			<td class="data-area-canvas-odd"><xsl:value-of select="deviceName"/></td>
			<td class="data-area-canvas-odd">Status</td>
			<xsl:choose>
				<xsl:when test="string-length(normalize-space($status))=0">
					<td class="data-area-canvas-odd"><img style="width: 15px; height: 15px;" src="./images/info.gif"></img>No Information Available.</td>
				</xsl:when>
				<xsl:otherwise>
					<td class="data-area-canvas-odd">
						<!-- Get Image based on Status-->
						<xsl:if test="$statuscode=0">
							<img style="width: 15px; height: 15px;" src="./images/ok.gif"></img>
						</xsl:if>
						<xsl:if test="$statuscode=100">
							<img style="width: 15px; height: 15px;" src="./images/unknown.gif"></img>
						</xsl:if>	
						<xsl:if test="not($statuscode =0) and not($statuscode=100)">
							<img style="width: 15px; height: 15px;" src="./images/warn.gif"></img>
						</xsl:if>
						<xsl:value-of select="$status"/>
					</td>
				</xsl:otherwise>
			</xsl:choose>
		</tr>	
		<xsl:for-each select="*">
			<xsl:if test="not(name()='deviceStatus') and not(name()='deviceStatusCode') and not(name()='deviceName') and not(name()='_Key') and not(starts-with(name(), 'Dev_Char_V'))">
	       		<tr>
					<td class="data-area-canvas-odd"></td>
					<xsl:choose>
						<xsl:when test="name()='deviceAdditionalInformation'">
							<td class="data-area-canvas-odd"><xsl:value-of select="'Additional Information'"></xsl:value-of><img style="width: 10px; height: 10px;" src="./images/blank.gif"></img></td>
						</xsl:when>
						<xsl:when test="starts-with(name(), 'Dev_Char_N')">
							<td class="data-area-canvas-odd"><xsl:value-of select="./text()"/><img style="width: 10px; height: 10px;" src="./images/blank.gif"></img></td>
						</xsl:when>
						<xsl:otherwise>
							<td class="data-area-canvas-odd"><xsl:value-of select="substring(name(),7)"></xsl:value-of><img style="width: 10px; height: 10px;" src="./images/blank.gif"></img></td>
						</xsl:otherwise>
					</xsl:choose>			
					<xsl:choose>
						<xsl:when test="string-length(normalize-space(.))=0">
							<td class="data-area-canvas-odd">No Information Available.</td>
						</xsl:when>
						<xsl:otherwise><xsl:choose><xsl:when test="name()='deviceLocation'"><td class="data-area-canvas-odd"><xsl:call-template name="GiveOnlyLocation"><xsl:with-param name="devLocation" select="."/></xsl:call-template></td></xsl:when><xsl:when test="starts-with(name(), 'Dev_Char_N')"><xsl:variable name="suffixVal">Dev_Char_V_<xsl:value-of select="substring-after(name(), 'Dev_Char_N_')"/></xsl:variable><td class="data-area-canvas-odd"><xsl:value-of select="../*[name()=$suffixVal]/text()"/><img style="width: 10px; height: 10px;" src="./images/blank.gif"></img></td></xsl:when><xsl:otherwise><td class="data-area-canvas-odd"><xsl:value-of select="."/></td></xsl:otherwise></xsl:choose>
						</xsl:otherwise>
					</xsl:choose>
	       		</tr>
			</xsl:if>
		</xsl:for-each>
	</xsl:if>
    	<xsl:if test="$not_canvas">
    		<tr>
			<td><xsl:value-of select="deviceName"/></td>
			<td>Status</td>
			<xsl:choose>
				<xsl:when test="string-length(normalize-space($status))=0">
					<td><img style="width: 15px; height: 15px;" src="./images/info.gif"></img>No Information Available.</td>
				</xsl:when>
				<xsl:otherwise>
					<td>
						<!-- Get Image based on Status-->
						<xsl:if test="$statuscode=0">
							<img style="width: 15px; height: 15px;" src="./images/ok.gif"></img>
						</xsl:if>
						<xsl:if test="$statuscode=100">
							<img style="width: 15px; height: 15px;" src="./images/unknown.gif"></img>
						</xsl:if>	
						<xsl:if test="not($statuscode =0) and not($statuscode=100)">
							<img style="width: 15px; height: 15px;" src="./images/warn.gif"></img>
						</xsl:if>
						<xsl:value-of select="$status"/>
					</td>
				</xsl:otherwise>
			</xsl:choose>
		</tr>
		<xsl:for-each select="*">
			<xsl:if test="not(name()='deviceStatus') and not(name()='deviceStatusCode') and not(name()='deviceName') and not(name()='_Key') and not(starts-with(name(), 'Dev_Char_V'))">
	       		<tr>
					<td></td>
					<xsl:choose>
						<xsl:when test="name()='deviceAdditionalInformation'">
							<td><xsl:value-of select="'Additional Information'"></xsl:value-of><img style="width: 10px; height: 10px;" src="./images/blank.gif"></img></td>
						</xsl:when>
						<xsl:when test="starts-with(name(), 'Dev_Char_N')">
							<td><xsl:value-of select="./text()"/><img style="width: 10px; height: 10px;" src="./images/blank.gif"></img></td>
						</xsl:when>
						<xsl:otherwise>
							<td><xsl:value-of select="substring(name(),7)"></xsl:value-of><img style="width: 10px; height: 10px;" src="./images/blank.gif"></img></td>
						</xsl:otherwise>
					</xsl:choose>
					<xsl:choose>
						<xsl:when test="string-length(normalize-space(.))=0">
							<td>No Information Available.</td>
						</xsl:when>
						<xsl:otherwise><xsl:choose><xsl:when test="name()='deviceLocation'"><td><xsl:call-template name="GiveOnlyLocation"><xsl:with-param name="devLocation" select="."/></xsl:call-template></td></xsl:when><xsl:when test="starts-with(name(), 'Dev_Char_N')"><xsl:variable name="suffixVal">Dev_Char_V_<xsl:value-of select="substring-after(name(), 'Dev_Char_N_')"/></xsl:variable><td><xsl:value-of select="../*[name()=$suffixVal]/text()"/><img style="width: 10px; height: 10px;" src="./images/blank.gif"></img></td></xsl:when><xsl:otherwise><td><xsl:value-of select="."/></td></xsl:otherwise></xsl:choose>
						</xsl:otherwise>
					</xsl:choose>
				</tr>
			</xsl:if>
		</xsl:for-each>
	</xsl:if>
</xsl:template>

<xsl:template name="GiveOnlyLocation">
	<xsl:param name="devLocation"/>
	<xsl:choose><xsl:when test="contains($devLocation, '!')"><xsl:call-template name="GiveOnlyLocation"><xsl:with-param name="devLocation" select="substring-after($devLocation, '!')"/></xsl:call-template></xsl:when>	<xsl:otherwise><xsl:value-of select="normalize-space($devLocation)"/></xsl:otherwise></xsl:choose>
</xsl:template>
	
</xsl:stylesheet>
